package com.flooded;


import java.util.Calendar;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.*;

import PushNotification.AlertDialogManager;
import PushNotification.ConnectionDetector;
import PushNotification.ServerUtilities;

import static PushNotification.CommonUtilities.DISPLAY_MESSAGE_ACTION;
import static PushNotification.CommonUtilities.SENDER_ID;
import static PushNotification.CommonUtilities.EXTRA_MESSAGE;

import PushNotification.WakeLocker;
import com.facebook.Request;
import com.facebook.Response;
import com.facebook.Session;
import com.facebook.SessionState;
import com.facebook.UiLifecycleHelper;
import com.facebook.model.GraphUser;
import com.flooded.helperClasses.Dialog;
import com.flooded.helperClasses.HTTPHandler;
import com.flooded.helperClasses.Helper;
import com.google.android.gcm.GCMRegistrar;


public class MainActivity extends Activity {

	  private UiLifecycleHelper uiHelper;
	  private static String username = "";
	  static boolean usernameSet;
	  private boolean isInFront;
		// Asyntask
		AsyncTask<Void, Void, Void> mRegisterTask;
		
		// Alert dialog manager
		AlertDialogManager alert = new AlertDialogManager();
		
		// Connection detector
		ConnectionDetector cd;
		
	  
	  public static String notifyName, email, fbid;
	  
	  public static void commitUsername(String username, Context context) {
		  SharedPreferences settings = ((MainActivity)context).getSharedPreferences(PREFS_NAME, 0);
		  SharedPreferences.Editor editor = settings.edit();
		  editor.putString("username", username);
		  editor.commit();
	}
	
		  
	  public static boolean isUsernameSet() {
		if(!username.equalsIgnoreCase("") && !username.equals(" ")){
			return true;
		} else{
			return false;
		}
	}
	  
	  public static final String PREFS_NAME = "MyData";
	  
	  
	  private Session.StatusCallback callback = new Session.StatusCallback() {
		    @Override
		    public void call(Session session, SessionState state, Exception exception) {
		        onSessionStateChange(session, state, exception);
		    }
		};
	 boolean test = true;
	 TextView countdown;
	 long duration = 3600000;
	 private String playerID, name;
     public ProgressDialog progressDialog;
     private HTTPHandler HttpHandler;
		
		 private void toast(String message) {
			     	Toast.makeText(
			     			getApplicationContext(),
			     			message,
			     			Toast.LENGTH_SHORT).show();
			     }
		
  @Override
  public void onCreate(Bundle savedInstanceState) {
      super.onCreate(savedInstanceState);
      
	    uiHelper = new UiLifecycleHelper(this, callback);
	    uiHelper.onCreate(savedInstanceState);
	    HttpHandler = new HTTPHandler();
	    
	    
	    
	    SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
	    username = settings.getString("username", "");
	    
     
    	
	   
        
        // Start Facebook login
         Session.openActiveSession(this, true, callback); 
      
           //unclickableButtons();

	    
      
  }
  
  
  public void initPushNotifications(){
		cd = new ConnectionDetector(getApplicationContext());

		// Check if Internet present
		if (!cd.isConnectingToInternet()) {
			// Internet Connection is not present
			alert.showAlertDialog(MainActivity.this,
					"Internet Connection Error",
					"Please connect to working Internet connection", false);
			// stop executing code by return
			return;
		}
		
		
		
		notifyName = username; 
		email = "test2";
		
		// Make sure the device has the proper dependencies.
		GCMRegistrar.checkDevice(this);

		// Make sure the manifest was properly set - comment out this line
		// while developing the app, then uncomment it when it's ready.
		GCMRegistrar.checkManifest(this);

		
		registerReceiver(mHandleMessageReceiver, new IntentFilter(
				DISPLAY_MESSAGE_ACTION));
		
		// Get GCM registration id
		final String regId = GCMRegistrar.getRegistrationId(this);

		// Check if regid already presents
		if (regId.equals("")) {
			// Registration is not present, register now with GCM			
			GCMRegistrar.register(this, SENDER_ID);
		} else {
			// Device is already registered on GCM
			if (GCMRegistrar.isRegisteredOnServer(this)) {
				// Skips registration.				
				//Toast.makeText(getApplicationContext(), "Already registered with GCM", Toast.LENGTH_LONG).show();
			} else {
				// Try to register again, but not in the UI thread.
				// It's also necessary to cancel the thread onDestroy(),
				// hence the use of AsyncTask instead of a raw thread.
				final Context context = this;
				mRegisterTask = new AsyncTask<Void, Void, Void>() {

					@Override
					protected Void doInBackground(Void... params) {
						// Register on our server
						// On server creates a new user
						ServerUtilities.register(context, name, email, regId, fbid);
						return null;
					}

					@Override
					protected void onPostExecute(Void result) {
						mRegisterTask = null;
					}

				};
				mRegisterTask.execute(null, null, null);
			}
		}
  }
  
  
  /**
	 * Receiving push messages
	 * */
	private final BroadcastReceiver mHandleMessageReceiver = new BroadcastReceiver() {
		
		
		@Override
		public void onReceive(Context context, Intent intent) {
			if(isInFront){
			String newMessage = intent.getExtras().getString(EXTRA_MESSAGE);
			// Waking up mobile if it is sleeping
			WakeLocker.acquire(getApplicationContext());
			
			/**
			 * Take appropriate action on this message
			 * depending upon your app requirement
			 * For now i am just displaying it on the screen
			 * */
			
			
			String[] analyzedMessage = newMessage.split(" ");
			if(analyzedMessage.length!= 0){
			if(analyzedMessage[0].equalsIgnoreCase("newsandbag")){
				
			 } else if(analyzedMessage[0].equalsIgnoreCase("updatequest")){
				 
			 } else if(analyzedMessage[0].equalsIgnoreCase("evacuatenow")){
				 
			 } else if(analyzedMessage[0].equalsIgnoreCase("tutorialstarted")){
				 
			 } else if (analyzedMessage[0].equalsIgnoreCase("extrapoints")){
				 
			 }  else if (analyzedMessage[0].equalsIgnoreCase("zonesearched")){
				 
			 }  else if (analyzedMessage[0].equalsIgnoreCase("zonenotified")){
				 
			 } else if(analyzedMessage[0].equalsIgnoreCase("playeroffline")){
				 
			 } else if(analyzedMessage[0].equalsIgnoreCase("playermoved")){
				 
			 } else{
					Toast.makeText(getApplicationContext(), "New Message: " + newMessage, Toast.LENGTH_LONG).show();
					
			 }
			}
		
			// Releasing wake lock
			WakeLocker.release();
			}
		}
	};
	
  




//Show dialog for finished SNR quest
public static void showUsernameDialog(final Context context, final String playerID, final HTTPHandler httphandler){

    
	AlertDialog.Builder builder = new AlertDialog.Builder(context);
	    // Get the layout inflater
	    LayoutInflater inflater = ((Activity)context).getLayoutInflater();
	    View view = inflater.inflate(R.layout.username, null);
	    // Inflate and set the layout for the dialog
	    // Pass null as the parent view because its going in the dialog layout
	    builder.setView(view);
	    builder.setCancelable(false);
	    final EditText userName = (EditText)view.findViewById(R.id.userName);

	    
	    builder.setTitle("Choose a username!");
	    
	    // Add action buttons
	           builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
	               @Override
	               public void onClick(DialogInterface dialog, int id) {
	            	   
	            	   if(!userName.getText().toString().equals("")){
	            		   username = userName.getText().toString();
	            		   Log.w("Username is: " + username, "debug");
	            		   httphandler.getPlayer(context, playerID, username);
	            		   
	            	   }
	            	   
	            	   if(username.equals("") || username.equals(" ") ){
	            		   Log.w("Username is: " + username, "debug");
	            		   if(!isUsernameSet()){
	            			   Helper.displayText("Username was empty.", context, true);
	            			   showUsernameDialog(context, playerID, httphandler);
	            		   }
	            	   } else if(username.length() > 20){
	            		   if(!isUsernameSet()){
	            		   Helper.displayText("Username was too long. Maximum is 20 characters.", context, true);
	            		   showUsernameDialog(context, playerID, httphandler);
	            		   }
	            	   } else{
	            		  ((MainActivity)context).initPushNotifications();
	            		   commitUsername(username, context);
	            	   }
	            
	               }
	           });

		AlertDialog dialog = builder.create();
		dialog.setView(view, 0, 0, 0, 0);
		dialog.show();
	    
} // end showSNR
  
  
  // Set up buttons so that it wont crash when players click before they should
  public void unclickableButtons(){
      final Button button = (Button) findViewById(R.id.button1);
      button.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
          }
      });
      
      final Button button2 = (Button) findViewById(R.id.button2);
      button2.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
          }
      });
      
      final Button button3 = (Button) findViewById(R.id.button3);
      button3.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
          }
      });
      
//      final Button instructionsButton = (Button) findViewById(R.id.instructionsButton);
//      instructionsButton.setOnClickListener(new View.OnClickListener() {
//          public void onClick(View v) {
// 
//          }
//      });
      
      final Button inboxButton = (Button) findViewById(R.id.inboxButton);
      inboxButton.setOnClickListener(new View.OnClickListener()    {
		public void onClick(View v) {
		}
	});

      final Button logOutButton = (Button) findViewById(R.id.logoutButton);
     logOutButton.setOnClickListener(new View.OnClickListener() {
    	  public void onClick(View v) {
   			finish();
	      }
      });
      
      
      final Button friendsButton = (Button) findViewById(R.id.friendsButton);
      friendsButton.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) { 	  
          }
      });
  } // end unclickable buttons
  
  // Initialize buttons with onClickListener when Facebook session has been opened
  
  public void initializeButtons(){
      final Button button = (Button) findViewById(R.id.button1);
      button.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  HttpHandler.getQuests(MainActivity.this, playerID);
          }
      });
      
      final Button button2 = (Button) findViewById(R.id.button2);
      button2.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  HttpHandler.getPlayerInfo(MainActivity.this, playerID);
          }
      });
      
      final Button button3 = (Button) findViewById(R.id.button3);
      button3.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  HttpHandler.retrievePlayers(MainActivity.this);
        	  
          }
      });
      
//      final Button resetButton = (Button) findViewById(R.id.resetButton);
//      resetButton.setOnClickListener(new View.OnClickListener() {
//          public void onClick(View v) {
//        	  HttpHandler.tutorialFinished(MainActivity.this);
//          }
//      });
      
      final Button inboxButton = (Button) findViewById(R.id.inboxButton);
      inboxButton.setOnClickListener(new View.OnClickListener()    {
		public void onClick(View v) {
			Intent i = new Intent(MainActivity.this, InboxActivity.class);
      		i.putExtra("playerID", playerID);
			startActivity(i);
		}
	});

      final Button logOutButton = (Button) findViewById(R.id.logoutButton);
      logOutButton.setOnClickListener(new View.OnClickListener() {
    	  public void onClick(View v) {
	          toast("Logged out!");
	          HttpHandler.updatePlayerStatus(MainActivity.this, playerID);
	          finish();
	      }
      });
      
      
      final Button friendsButton = (Button) findViewById(R.id.friendsButton);
      friendsButton.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  Intent intent = new Intent(MainActivity.this, GameFriendsActivity.class);
        	  intent.putExtra("fbid", playerID);
        	  startActivity(intent);        	  
          }
      });
  }

 
	
	

  private void onSessionStateChange(Session session, SessionState state, Exception exception) {
    // user has either logged in or not ...
	 
    if (session.isOpened()) {
    	Log.w("Facebook session OK", "Facebook session OK");
    // make request to the /me API
      Request request = Request.newMeRequest(session, new Request.GraphUserCallback() {
        // callback after Graph API response with user object
        @Override
        public void onCompleted(GraphUser user, Response response) {
          if (user != null) {
      	    setContentView(R.layout.new_main);
            //TextView welcome = (TextView) findViewById(R.id.welcome);
            playerID = user.getId();
            fbid = playerID;
            name = user.getName();
            //welcome.setText("Hello " + user.getName() + "!");
        
            if(!isUsernameSet()){
            	showUsernameDialog(MainActivity.this, playerID, HttpHandler);
            } else{
            	initPushNotifications();
        	    HttpHandler.getPlayer(MainActivity.this, playerID, username);
        	    
            }
            
            initializeButtons();
          }
        }
      });
      Request.executeBatchAsync(request);
    } else if(state.isClosed()){
    	Log.w("Facebook error", "Facebook error");
    }
  }

  @Override
  public void onActivityResult(int requestCode, int resultCode, Intent data) {
      super.onActivityResult(requestCode, resultCode, data);
      uiHelper.onActivityResult(requestCode, resultCode, data);
      Session.getActiveSession().onActivityResult(this, requestCode, resultCode, data);
  }
  
  
  @Override
protected void onDestroy() {
	super.onDestroy();
	uiHelper.onDestroy();
	
// 	Unlisten to push notifications
	if (mRegisterTask != null) {
		mRegisterTask.cancel(true);
	}
	try {
		unregisterReceiver(mHandleMessageReceiver);
		GCMRegistrar.onDestroy(this);
	} catch (Exception e) {
		Log.e("UnRegister Receiver Error", "> " + e.getMessage());
	}
	
}
  
  @Override
protected void onSaveInstanceState(Bundle outState) {
	super.onSaveInstanceState(outState);
	uiHelper.onSaveInstanceState(outState);
}
  

  
   @Override
protected void onResume() {
	   super.onResume();
	   uiHelper.onResume();
	   isInFront = true;
}

   @Override
protected void onPause() {
	super.onPause();
	uiHelper.onPause();
	isInFront = false;

	
}

   @Override
protected void onStop() {
	super.onStop();
}

  
  
}