package com.flooded.helperClasses;

import android.graphics.Bitmap;
import android.widget.BaseAdapter;

public class FriendListItem {
	private String name;
	private Bitmap bitmap;
	private int position;
	private BaseAdapter adapter;
	
	private String id;

    public FriendListItem(String id, String name) {
    	this.id = id;
    	setName(name);
    }
    
    public String getId() {
		return id;
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
		notifyAdapter();
	}

	public Bitmap getBitmap() {
		return bitmap;
	}

	public void setBitmap(Bitmap bitmap) {
		this.bitmap = bitmap;
		notifyAdapter();
	}
	
	public int getPosition() {
		return position;
	}

	public void setPosition(int position) {
		this.position = position;
	}

	public void setAdapter(BaseAdapter adapter) {
	    this.adapter = adapter;
	}
	
	protected void notifyAdapter() {
		if (adapter != null) {
		    adapter.notifyDataSetChanged();
		}
	}

}