package com.flooded.gameEntities;

import android.location.Location;

public class QuestObject {
	
	
	private boolean completed;
	private double longitude;
	private double latitude;
	private int id;
	private Location location;
	private boolean crate = false;
	private int taggedby;
	private int type;
	
	
	public QuestObject (double latitude, double longitude) {
	
		this.longitude = longitude;
		this.latitude = latitude;
		this.location = new Location("GPS");
		location.setLatitude(latitude);
		location.setLongitude(longitude);
		this.completed = false;
		this.taggedby = 0;
		
	}
	
	public void setType(int type) {
		this.type = type;
	}
	public int getType() {
		return type;
	}
	
	public boolean isCrate() {
		return crate;
	}
	
	public void setCrate(boolean crate) {
		this.crate = crate;
	}
	
	public void setTaggedby(int taggedby) {
		this.taggedby = taggedby;
	}
	public int getTaggedby() {
		return taggedby;
	}

	
	public int getId() {
		return id;
	}
	
	public void setId(int id) {
		this.id = id;
	}
	
	public double getLatitude() {
		return latitude;
	}
	
	public double getLongitude() {
		return longitude;
	}
	
	public boolean isCompleted() {
		return completed;
	}
	public void setCompleted(boolean completed) {
		this.completed = completed;
	}
	
	public Location getLocation() {
		return location;
	}
}
